%Optimierung im Zeitbereich, Minimum-Berechnung
%Betragsregelflche IAE
%optimierung_IAE_step.m
%Eingangsgre Sprungfunktion

clear, clf, clc, format long

delta_t = 0.0001; tmax = 150.0; nn = round (tmax / delta_t);
x = zeros (nn+1,1); t = 0:delta_t:tmax; w = ones(nn+1,1);
dfa = 1.0e-4; df_min = 0.75e-4; nmax = 8;

berechne = 1; n = 2; %Ergebnisse
A_IAE = 1.605143555496869; ue = 0.062185573413985; tanr = 3.0632;
f1m =  1.3247546875;
%Minimum-Berechnung
A_min = inf; df =  dfa;
while df > 0.01*df_min && berechne == 1
    anz_min = 1; j = 0;
while anz_min > 0
    anz_min = 0;
for f1 = f1m-df:df:f1m+df
    G_IAE_s(n) = tf(1, [1 f1 1]); x = step(G_IAE_s(n), t);
    A = delta_t * trapz(abs(w - x));
    if A_min > A + eps
       A_min = A; ue = max(x) - 1.0; anz_min = anz_min + 1;
       f1_min = f1;
       k = 1;
       while x(k) < 1.0
           k = k + 1;
       end
       tanr = t(k);
    end
end
j = j + 1, df, anz_min, ue, tanr, A_IAE = A_min, f1m = f1_min,
end
df = df / 2.0;
end
G_IAE_s(n) = tf(1, [1 f1m 1]);
n, nullstellen = roots(G_IAE_s(n).den{1})

berechne = 0; n = 3; %Ergebnisse
A_IAE =   2.162750313322281; ue = 0.026366420190581; tanr = 3.6407;
f1m =  2.0899; f2m =  1.4793;
%Minimum-Berechnung
A_min = inf; df =  dfa;
while df > df_min && berechne == 1
    anz_min = 1; j = 0;
while anz_min > 0
    anz_min = 0;
for f1 = f1m-df:df:f1m+df
    for f2 = f2m-df:df:f2m+df
        G_IAE_s(n) = tf(1, [1 f2 f1 1]); x = step(G_IAE_s(n), t);
        A = delta_t * trapz(abs(w - x));
        if A_min > A + eps
           A_min = A; ue = max(x) - 1.0; anz_min = anz_min + 1;
           f1_min = f1; f2_min = f2;
           k = 1;
           while x(k) < 1.0
              k = k + 1;
           end
           tanr = t(k);
        end
    end
end
j = j + 1, df, anz_min,  ue, tanr, A_IAE = A_min, f1m = f1_min, f2m = f2_min,
end
df = df / 2.0;
end
G_IAE_s(n) = tf(1, [1 f2m f1m 1]);
n, nullstellen = roots(G_IAE_s(n).den{1})

berechne = 0; n = 4; %Ergebnisse
A_IAE =   2.707196815658044; ue = 0.046642965027855; tanr = 4.2153;
f1m =  2.4527; f2m =  3.1788; f3m =  1.5703; 
%Minimum-Berechnung
A_min = inf; df = dfa;
while df > df_min && berechne == 1
anz_min = 1;
while anz_min > 0
    anz_min = 0; j = 0;
for f1 = f1m-df:df:f1m+df
    for f2 = f2m-df:df:f2m+df
        for f3 = f3m-df:df:f3m+df
            G_IAE_s(n) = tf (1, [1 f3 f2 f1 1]);
            x = step(G_IAE_s(n), t);
            A = delta_t * trapz(abs(w - x));
        if A_min > A + eps
           A_min = A; ue = max(x) - 1.0; anz_min = anz_min + 1;
           f1_min = f1; f2_min = f2; f3_min = f3;
           k = 1;
           while x(k) < 1.0
              k = k + 1;
           end
           tanr = t(k);
        end
        end
    end
end
j = j + 1, df, anz_min, ue, tanr, A_IAE = A_min,
f1m = f1_min, f2m = f2_min, f3m = f3_min,
end
df = df / 2.0;
end
G_IAE_s(n) = tf (1, [1 f3m f2m f1m 1]);
n, nullstellen = roots(G_IAE_s(n).den{1})

berechne = 0; n = 5; %Ergebnisse
A_IAE =   3.247380270559342; ue = 0.027075494022441; tanr = 4.7872;
f1m =  3.1456; f2m =  4.1400; f3m =  4.2589; f4m =  1.6363;
%Minimum-Berechnung
A_min = inf; df = dfa;
while df > df_min && berechne == 1
anz_min = 1; j = 0;
while anz_min > 0
    anz_min = 0;
for f1 = f1m-df:df:f1m+df
    for f2 = f2m-df:df:f2m+df
        for f3 = f3m-df:df:f3m+df
            for f4 = f4m-df:df:f4m+df
                G_IAE_s(n) = tf (1, [1 f4 f3 f2 f1 1]);
                x = step(G_IAE_s(n), t);
                A = delta_t * trapz(abs(w - x));
                if A_min > A + eps
                   A_min = A; ue = max(x) - 1.0; anz_min = anz_min + 1;
                   f1_min = f1; f2_min = f2; f3_min = f3; f4_min = f4;
                   k = 1;
                   while x(k) < 1.0
                      k = k + 1;
                   end
                   tanr = t(k);
                end
             end
        end
    end
end
j = j + 1, df, anz_min, ue, tanr, A_IAE = A_min,
f1m = f1_min, f2m = f2_min, f3m  = f3_min, f4m = f4_min
end
df = df / 2.0;
end
G_IAE_s(n) = tf (1, [1 f4m f3m f2m f1m 1]);
n, nullstellen = roots(G_IAE_s(n).den{1})

berechne = 0; n = 6; %Ergebnisse
A_IAE =   3.786063340597936; ue = 0.035926655856189; tanr = 5.3543;
f1m =  3.5486; f2m = 6.4470; f3m = 5.9753; f4m = 5.3335; f5m = 1.6908;
%Minimum-Berechnung
A_min = inf; df = dfa;
while df > df_min && berechne == 1
    anz_min = 1; j = 0;
while anz_min > 0
    anz_min = 0;
for f1 = f1m-df:df:f1m+df
    for f2 = f2m-df:df:f2m+df
        for f3 = f3m-df:df:f3m+df
            for f4 = f4m-df:df:f4m+df
                for f5 = f5m-df:df:f5m+df
                    G_IAE_s(n) = tf (1, [1 f5 f4 f3 f2 f1 1]);
                    x = step(G_IAE_s(n), t);
                    A = delta_t * trapz(abs(w - x));
                    if A_min > A + eps
                       A_min = A; ue = max(x) - 1.0; anz_min = anz_min + 1;
                       f1_min = f1; f2_min = f2; f3_min = f3; f4_min = f4;
                       f5_min = f5;
                       k = 1;
                       while x(k) < 1.0
                          k = k + 1;
                       end
                       tanr = t(k);
                    end
                end
            end
        end
    end
end
j = j + 1, df, anz_min, ue, tanr, A_IAE = A_min,
f1m = f1_min, f2m = f2_min, f3m = f3_min, f4m = f4_min, f5m = f5_min
end
df = df / 2.0;
end
G_IAE_s(n) = tf (1, [1 f5m f4m f3m f2m f1m 1]);
n, nullstellen = roots(G_IAE_s(n).den{1})

berechne = 0; n = 7; %Ergebnisse
A_IAE =  4.323956082438747; ue =  0.033393369698420; tanr = 5.9166;
f1m = 4.1952; f2m = 7.9559; f3m = 10.8981;
f4m = 7.9203; f5m = 6.4054; f6m =  1.7394;
%Minimum-Berechnung
A_min = inf; df = dfa;
while df > df_min && berechne == 1
    anz_min = 1; j = 0;
while anz_min > 0
    anz_min = 0;
for f1 = f1m-df:df:f1m+df
    f1
    for f2 = f2m-df:df:f2m+df
        for f3 = f3m-df:df:f3m+df
            for f4 = f4m-df:df:f4m+df
                for f5 = f5m-df:df:f5m+df
                    for f6 = f6m-df:df:f6m+df
                    G_IAE_s(n) = tf (1, [1 f6 f5 f4 f3 f2 f1 1]);
                    x = step(G_IAE_s(n), t);
                    A = delta_t * trapz(abs(w - x));
                    if A_min > A + eps
                    A_min = A; ue = max(x) - 1.0; anz_min = anz_min + 1;
                    f1_min = f1; f2_min = f2; f3_min = f3;
                    f4_min = f4; f5_min = f5; f6_min = f6;
                    k = 1;
                    while x(k) < 1.0
                       k = k + 1;
                    end
                    tanr = t(k);
                    end
                    end
                end
            end
        end
    end
end
j = j + 1, df, anz_min, ue, tanr, A_IAE = A_min,
f1m = f1_min, f2m = f2_min, f3m = f3_min
f4m = f4_min, f5m = f5_min, f6m = f6_min
end
df = df / 2.0;
end
G_IAE_s(n) = tf (1, [1 f6m f5m f4m f3m f2m f1m 1]);
n, nullstellen = roots(G_IAE_s(n).den{1})

berechne = 0; n = 8; %Ergebnisse
A_IAE =   4.861153390275208; ue = 0.036023937287789; tanr = 6.4865;
f1m =  4.6356; f2m = 10.8212; f3m = 14.4801;
f4m = 16.5119; f5m = 10.0215; f6m =  7.4799; f7m =  1.8014;
%Minimum-Berechnung
A_min = inf; df = dfa;
while df > df_min && berechne == 1
    anz_min = 1; j = 0;
while anz_min > 0
    anz_min = 0;
for f1 = f1m-df:df:f1m+df
f1
    for f2 = f2m-df:df:f2m+df
        for f3 = f3m-df:df:f3m+df
            for f4 = f4m-df:df:f4m+df
                for f5 = f5m-df:df:f5m+df
                    for f6 = f6m-df:df:f6m+df
                    for f7 = f7m-df:df:f7m+df
                    G_IAE_s(n) = tf (1, [1 f7 f6 f5 f4 f3 f2 f1 1]);
                    x = step(G_IAE_s(n), t);
                    A = delta_t * trapz(abs(w - x));
                    if A_min > A + eps
                    A_min = A; ue = max(x) - 1.0; anz_min = anz_min + 1;
                    f1_min = f1; f2_min = f2; f3_min = f3; f4_min = f4;
                    f5_min = f5; f6_min = f6; f7_min = f7;
                    k = 1;
                    while x(k) < 1.0
                       k = k + 1;
                    end
                    tanr = t(k);
                    end
                    end
                    end
                end
            end
        end
    end
end
j = j + 1, df, anz_min, ue, tanr, A_IAE = A_min,
f1m = f1_min, f2m = f2_min, f3m = f3_min
f4m = f4_min, f5m = f5_min, f6m = f6_min, f7m = f7_min
end
df = df / 2.0;
end
G_IAE_s(n) = tf (1, [1 f7m f6m f5m f4m f3m f2m f1m 1]);
n, nullstellen = roots(G_IAE_s(n).den{1})

t = 0:10.0*delta_t:20;
w = ones(length(t),1);
figure (1)
for n = 2:nmax
        x = step(G_IAE_s(n), t);
        plot(t, x), axis ([0 20 0  1.1])
        hold on, grid on
end
plot(t, w, 'k')
title('Optimierung im Zeitbereich, IAE-Kriterium')
xlabel('Normierte Zeit \omega_k * t')
ylabel('Sprungantwort x(t)')

figure (2)
for n = 2:nmax
        x = step(G_IAE_s(n), t);
        plot(t, (w - x))
        hold on, grid on
end
title('IAE-Kriterium, Stellungsfehler fr w(t) = E(t), \omega_k = 1 s-1')
xlabel('Zeit t / s')
ylabel('Regeldifferenz x_d(t) = w(t) - x(t)')

%{
n =  2 nullstellen =  
 -0.6624 + 0.7492i  -0.6624 - 0.7492i

n =  3 nullstellen =
 -0.4175 + 1.1737i  -0.4175 - 1.1737i
 -0.6444          

n =  4 nullstellen =
 -0.2749 + 1.4414i -0.2749 - 1.4414i
 -0.5102 + 0.4517i -0.5102 - 0.4517i

n =  5 nullstellen =
  -0.1891 + 1.6169i  -0.1891 - 1.6169i
  -0.3788 + 0.7813i  -0.3788 - 0.7813i
  -0.5005          

n =  6 nullstellen =
  -0.1341 + 1.7383i  -0.1341 - 1.7383i
  -0.2831 + 1.0287i  -0.2831 - 1.0287i
  -0.4281 + 0.3251i  -0.4281 - 0.3251i

n =  7 nullstellen =
  -0.0977 + 1.8262i  -0.0977 - 1.8262i
  -0.2155 + 1.2149i  -0.2155 - 1.2149i
  -0.3454 + 0.5881i  -0.3454 - 0.5881i
  -0.4222          

n =  8 nullstellen =
  -0.0740 + 1.8884i  -0.0740 - 1.8884i
  -0.1691 + 1.3556i  -0.1691 - 1.3556i
  -0.2796 + 0.8024i  -0.2796 - 0.8024i
  -0.3780 + 0.2547i  -0.3780 - 0.2547i
%}
